/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef FILoadContext_H
#define FILoadContext_H

#include <Foundation/Object.h>
#include <Foundation/UTTypeDesc.h>
#include <string>
#ifdef _WIN32
#include <WinBasis/WinBasis.h>
#else 
#include <sys/stat.h>
#endif


namespace Spr{;

/**	t@CObjectDescǂݏoCt@Cɏ񂾂肷邽߂̃f[^D
	ObjectDesc ւ̃|C^(data)  ^ (type) D
	̊ǗsD	*/
class FINodeData: public UTRefCount{
public:
	UTTypeDesc* type;	///<	f[^̌^ 
	UTString name;		///<	O
	void* data;			///<	[hf[^
	bool haveData;		///<	datadeleteׂǂD
	FINodeData(UTTypeDesc* t=NULL, void* d=NULL);
	~FINodeData();
};

class FINodeHandlers;
/**	t@C[hɎgpReLXg
	t@C[hۂ́Cf[^m[hƂɃ[hāC
	IuWFNg邽߂̃fBXNv^\(PHSolidDescȂ)
	܂[hD
	̂ƁCIuWFNg𐶐D	*/
class FILoadContext{
public:
	//--------------------------------------------------------------------------
	//	NX`
	///
	struct FileInfo{
		~FileInfo();
		std::string name;	///<		t@C
		const char* start;	///<		}bvꂽt@C̐擪
		const char* end;	///<		}bvꂽt@C̏I[
		const char* parsingPos;	///<	݂̃p[Xʒu
#ifdef _WIN32
		HANDLE hFile, hFileMap;		///<	t@CnhAt@C}bsOIuWFNg
#else 
		//FILE *hFile;
		//char *buffer;
		int fd;					///<	t@CfBXNv^
		struct stat filestat;	///<	t@CTCY𓾂̂Ɏg
		void *sourceptr;
#endif
		/// RXgN^
		FileInfo():start(NULL), end(NULL){}
		/// t@C }bsO		
		bool Map(std::string fn);
		/// t@C A}bsO
		void Unmap();
		///	[hłԂȂtrue
		bool IsGood();
	};
	///	^XNNXD[hɂ܂Ƃ߂Ďd邽߂̂́D
	class Task:public UTRefCount{
	public:
		virtual ~Task(){}
		virtual void Execute(FILoadContext* ctx)=0;	
	};
	///	^XNXg
	class Tasks:public std::vector< UTRef<Task> >{
	public:
		void Execute(FILoadContext* ctx);
	};
	///	m[hւ̎QƂL^ĂNXDS[hłĂ烊ND
	class LinkTask: public Task{
	public:
		std::vector<NameManagerIf*> nameManagers;
		std::string ref;
		ObjectIf* object;
		const char* pos;
		LinkTask(const ObjectIfs& objs, const char* p, ObjectIf* o, std::string r);
		void Execute(FILoadContext* ctx);
	};
	
	//--------------------------------------------------------------------------
	//	ϐ
	///	[h̃t@C̖OƒgDt@CincludeɔstackɂȂĂD
	UTStack<FileInfo> fileInfo;	
	///	݃[h̃IuWFNgDlXgIuWFNgɔăX^bNɂȂĂD
	ObjectIfs objects;
	///	X^bNɍŏɋl܂ꂽIuWFNgt@C̈ԊO[g̃IuWFNg̋L^D
	ObjectIfs rootObjects;
	///	[hfBXNv^̃X^bNDlXggݗČ^ɔăX^bNɂȂĂD
	UTStack< UTRef<FINodeData> > datas;
	///	[hFITypedesc̃tB[ḧʒuDgݗČ^̃tB[hɔăX^bNɂȂĂD
	UTTypeDescFieldIts fieldIts;
	///	G[bZ[Wo͗p̃Xg[ cout Ƃ DSTR w肷D
	std::ostream* errorStream;
	///	t@XŃN邽߂̋L^D
	Tasks links;
	///	[hƃNIĂ珈^XN
	Tasks postTasks;
	///	^DB
	UTTypeDescDb* typeDb;

	//---------------------------------------------------------------------------
	//	֐
	///
	FILoadContext():errorStream(NULL){
		errorStream=&DSTR;
	}
	///	G[bZ[W̏óDpost@CƍsԍɕϊD
	void ErrorMessage(const char* pos, const char* msg);
	///	bZ[W̍쐬Dpost@CƍsԍɕϊD
	void Message(const char* pos, const char* msg);
	///	[hłԂȂtrue
	bool IsGood();
	///	type鏀(typeZbgCXXDescpӂ)
	void PushType(UTTypeDesc* type);
	////
	void PopType();
	///
	void WriteString(std::string v);
	///
	void WriteNumber(double d);
	///
	void WriteBool(bool b);
	///
	void AddLink(std::string ref, const char* pos);
	///
	void Link();
	///
	void PostTask();
	///	m[h̍쐬
	void PushCreateNode(const IfInfo* info, const void* data);
};


}

#endif	// FILoadContext_H
