/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef FIOLDSPRINGHEADNODE_H
#define FIOLDSPRINGHEADNODE_H

namespace Spr{;
namespace SprOldSpringehead{;

///	\defgroup gpFIOldSpringheadNode (Springhead1)t@C[hp݊m[h
//@{
///	DirectXFrameD GRFrameɑΉ
struct Frame{
};
///	DirectXFrameTransformMatrixDt[̕ϊs\DGRFrame::transformɑΉD
struct FrameTransformMatrix{
	Affinef matrix;
};

///	Springehead1̌DGRLightɑΉD
struct Light8{
	int type;
    Vec4f diffuse;		///<	gU
    Vec4f specular;		///<	
    Vec4f ambient;
    Vec4f position;		///<	̈ʒuCw=0ƂƖ()ɂȂD
    float range;		///<	͈͂
    ///@name	DAtten = 1/( att0 + att1 * d + att2 * d^2)
	//@{
	float attenuation0;	///<	att0	0..
    float attenuation1;	///<	att1	0..
    float attenuation2;	///<	att2	0..
	//@}
	Vec3f spotDirection;///<	X|bgCg̏ꍇ̌
    float spotFalloff;	///<	̑(傫قǋ}s)		0..
	float spotInner;	///<	X|bgCg̒S		0..spotCutoff
	float spotCutoff;	///<	X|bgCǧ͈	0..
};

///	DirectX̃}eADGRMateiralɑΉD
struct Material{
	Vec4f face;
	float power;
	Vec3f specular;
	Vec3f emissive;
};


///	DirectXMesh̖ʁD
struct MeshFace{
	int nFaceVertexIndices;
	std::vector<int> faceVertexIndices;
};

///	DirectXMeshDGRMeshɑΉD
struct Mesh{
	int nVertices;
	std::vector<Vec3f> vertices;
	int nFaces;
	std::vector<MeshFace> faces;
	
};

///	DirectXMesh̖@xNg
struct MeshNormals{
	int nNormals;
	std::vector<Vec3f> normals;
	int nFaceNormals;
	std::vector<MeshFace> faceNormals;
};
///	DirectXMesh̃}eAXgD
struct MeshMaterialList{
	int nMaterials;
	int nFaceIndexes;
	std::vector<int> faceIndexes;
};
///	DirectXMesh̃eNX`WD
struct MeshTextureCoords{
	int nTextureCoords;
	std::vector<Vec2f> textureCoords;
};
//@}

}}
#endif
