/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
/**
 *	@file GRDeviceGL.h
 *	@brief OpenGLɂOtBbNX`̎@@
 */
#ifndef GRDEVICEGL_H
#define GRDEVICEGL_H

#include <map>
#include <SprGraphics.h>

namespace Spr{;

/**	@class	GRDeviceGL
    @brief	OpenGLɂOtBbNX`̎@ */
class GRDeviceGL: public InheritGRDevice<GRDeviceGLIf, GRDevice>{
	OBJECT_DEF(GRDeviceGL);
protected:
	int		window;					///<	EBhEID
	int		vertexFormatGl;			///<	glInterleavedArraysŎgC_tH[}bgID
	size_t	vertexSize;				///<	_̃TCY
	bool	vertexColor;			///<	_Fǂ
	GRMaterialDesc currentMaterial;	///<	݂̃}eA
	/**
	 *	@name	}gbNXϐ
	 *@@ GLłModelςViewςƂƂłȂB \n
	 *@@ _𓮂ɂ́A[UModeloĂKvB	\n
	 *@@ iDirect3D̏ꍇ́AModelViewA_𓮂Ƃłj
	 *	@{ 
	 */
	Affinef	viewMatrix;				///<	_s
	Affinef	modelMatrix;			///<	fs 
	Affinef	projectionMatrix;		///<	ˉes 
	/** @} */
	/**
	 *	@name	tHgϐ
	 *@@ VKɎw肳ꂽtHgfontListɊi[B
	 *	@{
	 */
	std::map<unsigned int, GRFont> fontList;		///<	tHgXg<DisplayListindex, font>    
	unsigned int	fontBase;						///<	fBXvCXgindex number̊ꐔ 
	/** @} */	
	int				nLights;		///<	̐
	
public:
	///	RXgN^
	GRDeviceGL(int w=0):window(w){}
	///	EBhEID̐ݒ
	virtual void SetWindow(int w){window=w;}
	/// ݒ
	virtual void Init();

	///	Viewportݒ
	virtual void SetViewport(Vec2f pos, Vec2f sz);
	///	obt@NA
	virtual void ClearBuffer();
	///	_O̊JnOɌĂԊ֐
	virtual void BeginScene();
	///	_ȌIɌĂԊ֐
	virtual void EndScene();
	///	fs
	virtual void MultModelMatrix(const Affinef& afw);
	///	fs̍sX^bNPush
	virtual void PushModelMatrix();
	///	fs̍sX^bNPop
	virtual void PopModelMatrix();
	///	fsݒ
	virtual void SetModelMatrix(const Affinef& afw);
	///	_sݒ
	virtual void SetViewMatrix(const Affinef& afv);
	///	esݒ
	virtual void SetProjectionMatrix(const Affinef& afp);
	
	///	_tH[}bg̎w
	virtual void SetVertexFormat(const GRVertexElement* e);
	///	_VF[_[̎w
	virtual void SetVertexShader(void* s);
	///	_Ww肵ăv~eBu`
	virtual void DrawDirect(TPrimitiveType ty, void* begin, size_t count, size_t stride=0);
	///	_WƃCfbNXw肵ăv~eBu`
	virtual void DrawIndexed(TPrimitiveType ty, size_t* idx, void* vtx, size_t count, size_t stride=0);
	///	DiplayList̍쐬
	virtual int CreateList(TPrimitiveType ty, void* vtx, size_t count, size_t stride=0);
	///	DiplayList̍쐬
	virtual int CreateIndexedList(TPrimitiveType ty, size_t* idx, void* vtx, size_t count, size_t stride=0);
	///	DisplayList̕\
	virtual void DrawList(int i);
	///	DisplayList̉
	virtual void ReleaseList(int i);
	/// 3eLXg̕`iGLI[łfont͎wȂj
	virtual void DrawFont(Vec2f pos, const std::string str);
	/// 3eLXg̕`iGLI[łfont͎wȂj
	virtual void DrawFont(Vec3f pos, const std::string str);
	///	3eLXg̕`
	virtual void DrawFont(Vec2f pos, const std::string str, const GRFont& font);
	///	3eLXg̕`
	virtual void DrawFont(Vec3f pos, const std::string str, const GRFont& font);
	///	`̍ގ̐ݒ
	virtual void SetMaterial(const GRMaterialDesc& mat);
	///	`悷_Ȇ̐ݒ
	virtual void SetLineWidth(float w);
	///	X^bNPush
	virtual void PushLight(const GRLightDesc& light);
	///	X^bNPop
	virtual void PopLight();
	///	fvXobt@ւ݂̏/֎~
	virtual void SetDepthWrite(bool b);
	///	fvXeXgL/ɂ
	virtual void SetDepthTest(bool b);
	///	fvXobt@@ɗp锻w肷
	virtual void SetDepthFunc(TDepthFunc f);
	/// At@ufBOL/ɂ
	virtual void SetAlphaTest(bool b);
	///	At@ufBÕ[hݒ(SRC̍W, DESTW)
	virtual void SetAlphaMode(TBlendFunc src, TBlendFunc dest);
};

}
#endif
