/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef GRSCENE_H
#define GRSCENE_H
#include <Graphics/SprGRScene.h>
#include <Foundation/Scene.h>
#include <Graphics/GRFrame.h>

namespace Spr {;

class GRCamera;
/**	V[Ot̃gbvm[hDE_D
	_ƃV[Ot̊֌W[߁C
	_ႤƃV[Ot͂̂܂܎gpłȂD
	V[Ot́CƂ΃_OpenGLȂCdisplayList
	Ă邵CD3DȂ ID3DXMeshĂD
*/
class SPR_DLL GRScene:public InheritScene<GRSceneIf, Scene>, public GRSceneDesc{
	OBJECT_DEF(GRScene);
protected:
	///	[gm[h
	UTRef<GRFrame> world;
	///	J
	UTRef<GRCamera> camera;
public:
	///	RXgN^
	GRScene(const GRSceneDesc& desc=GRSceneDesc());
	void Init();
	///	fXgN^
	~GRScene(){}

	GRSdkIf* GetSdk();

	///	V[ɂD
	void Clear();

	virtual GRFrameIf* CreateFrame(const GRFrameDesc& desc);
	virtual GRFrameIf* GetWorld(){return world;}
	virtual bool AddChildObject(ObjectIf* o);
	virtual size_t NChildObject() const;
	virtual ObjectIf* GetChildObject(size_t pos);
	virtual void Render(GRRenderIf* r);
protected:
	void* GetDescAddress(){ return (GRSceneDesc*)this; }
	friend class GRFrame;
};

}
#endif
