/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef PHCONSTRAINTENGINE_H
#define PHCONSTRAINTENGINE_H

#include <Physics/PHContactDetector.h>
#include <Physics/PHConstraint.h>

namespace Spr{;

class PHSolid;
class PHJoint;
class PHConstraintEngine;

///	`̑g
class PHShapePairForLCP : public CDShapePair{
public:
	void CalcNormal(PHSolid* solid0, PHSolid* solid1);
	///	ڐǴDڐG̐؂߂āC؂\ʑp`̒_engineɍSƂĒǉD
	void EnumVertex(PHConstraintEngine* engine, unsigned ct, PHSolidInfoForLCP* solid0, PHSolidInfoForLCP* solid1);
};

/// Solid̑g
class PHConstraintEngine;
class PHSolidPairForLCP : public PHSolidPair<PHSolidInfoForLCP, PHShapePairForLCP, PHConstraintEngine>{
public:
	virtual void OnDetect(PHShapePairForLCP* cp, PHConstraintEngine* engine, unsigned ct, double dt);
};

class PHConstraintEngine : public PHContactDetector<PHSolidInfoForLCP, PHShapePairForLCP, PHSolidPairForLCP, PHConstraintEngine>{
	typedef PHContactDetector<PHSolidInfoForLCP, PHShapePairForLCP, PHSolidPairForLCP, PHConstraintEngine> base_type;
	friend class PHConstraint;

	OBJECT_DEF_NOIF(PHConstraintEngine);

	PHJoint* CreateJoint(const PHJointDesc& desc);
	
public:
	PHConstraintEngine();
	~PHConstraintEngine();
	PHJoint* AddJoint(const PHJointDesc& desc);	///< ֐߂ǉit@C[_pj
	PHJoint* AddJoint(PHSolid* lhs, PHSolid* rhs, const PHJointDesc& desc);	///< ֐߂̒ǉ
	
	virtual int GetPriority() const {return SGBP_CONSTRAINTENGINE;}
	virtual void Step();			///< 
	virtual void Dynamics(double dt, int ct);		///< 
	//virtual void Correction(double dt, int ct);		///< 
	void UpdateSolids(double dt);	///< ʂSolidɔf
	virtual void Clear();

protected:
	PHConstraints	points;			///< ڐG_̔z
	PHConstraints	joints;			///< ֐߂̔z
	int max_iter_dynamics;			///< xXVLCP̔
	//int max_iter_correction;		///< 덷CLCP̔
	double correction_rate;			///< 덷C䗦
	//double max_error;

	void SetupDynamics(double dt);	///< xXVLCP̏
	void IterateDynamics();			///< xXVLCP̈x̔
	
	//void SetupCorrection(double dt);///< 덷CLCP̏
	//void IterateCorrection();		///< 덷CLCP̈x̔
	
	friend class PHShapePairForLCP;
};

}	//	namespace Spr
#endif
