/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef PHPATHJOINT_H
#define PHPATHJOINT_H

#include <SprPhysics.h>
#include "PHConstraint.h"

namespace Spr{;

/*	2̍̊Ԃ̑ΈʒuEpԂ֐
		[p; q] = f(s)
	ƂDp͑Έʒu, q͑quaternionCs͈ʉW\킷XJ[D
	
		[p'; q'] = (df/ds)(s)s'D
	quaternion̎Ԕpx𓾂sE(q)Ƃ
		[v; w] = [I O; O E(q(s))](df/ds)(s)s' =: J(s)s'
	̎ss'܂ΑΑx[v; w]܂D
	Š`ɕςD6xNgJ(s)͑Αx̌\킵Ă̂ŁC
	ɒsJ~(s)ƂƁCS
		J~(s)[v; w] = 0

	CorrectiońC
	velocity updatȇΈʒuɍł߂Oim(f)̓_擾C̓_ɍ킹D
	{̍S[p; q] in im(f)`Ȃ̂ňȂD
 */

/// ֐߂̋ÕL[t[C⊮ĕԂ胄RrAvZ肷NX
struct PHPathPointWithJacobian : public PHPathPoint{
	Matrix6d	J;
};

class PHPath : public std::vector<PHPathPointWithJacobian>, public InheritSceneObject<PHPathIf, SceneObject>{
	bool bReady;
	bool bLoop;	//[-pi, pi]̖]֐
	iterator Find(double s);
public:
	OBJECT_DEF_ABST(PHPath);
	virtual void SetLoop(bool OnOff = true){bLoop = OnOff;}
	virtual bool IsLoop(){return bLoop;}
	void AddPoint(double s, const Posed& pose);
	void CompJacobian();
	void GetPose(double s, Posed& pose);
	void GetJacobian(double s, Matrix6d& J);
	void Rollover(double& s);
	PHPath(const PHPathDesc& desc);
};

class PHPathJoint : public InheritJoint1D<PHPathJointIf, PHJoint1D>{
	OBJECT_DEF(PHPathJoint);
	UTRef<PHPath> path;
public:
	double	q, qd;				// ֐ߕψʂƊ֐ߊpx
	//Matrix53d	Jcvrel, Jcwrel;	// ΑxSxCΊpxSxւ̃Rrs

	virtual void SetPosition(double _q){q = _q;}
	virtual bool AddChildObject(ObjectIf* o);
	virtual PHConstraintDesc::ConstraintType GetConstraintType(){return PHConstraintDesc::PATHJOINT;}
	virtual double GetPosition();
	virtual double GetVelocity();
	virtual void	SetMotorTorque(double t){mode = MODE_TORQUE; fw.z = t;}
	virtual double	GetMotorTorque(){return fw.z;}
	//virtual void CompConstraintJacobian();
	virtual void CompBias(double dt, double correction_rate);
	//virtual void CompError(double dt);
	virtual void Projection(double& f, int k);
	//virtual void ProjectionCorrection(double& F, int k);
	PHPathJoint();
};

}

#endif
