/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
/**
 Springhead2/src/tests/HIS/HISpidarG6/main.cpp
yTvz
  OtBbNX_[NX DrawScene APIgAV[ꊇŃ_OB
  DrawScene API Őݒ肳Ă}eA}eATvpāAJtȃ{bNX_OB@
  ܂ASPIDARƂȂA̋yђnʂƗ͊oC^NVsB
  
yIz
  E5000XebvɋIB 

 */

#include <Springhead.h>		//	Springhead̃C^tF[X
#include <ctime>
#include <string>
#include <GL/glut.h>

#include "HIS/HIS.h"
#include <iostream>
#include <stdio.h>

#include <mmsystem.h>

#ifdef USE_HDRSTOP
#pragma hdrstop
#endif

using namespace Spr;

#define ESC				27			// ESC key
#define EXIT_TIMER		5000		// sXebv
#define WINSIZE_WIDTH	480			// EBhETCY(width)
#define WINSIZE_HEIGHT	360			// EBhETCY(height)
#define NUM_SPHERES		2			// sphere

#define HAPTIC_FREQ		1			// ͊oXbh̎(1/msec)
#define POINTER_RADIUS  1.0			// ͊o|C^̔a

#ifdef _WIN32		//	Win32(ʂ͂)
#include <Device/DRUsb20Simple.h>
#include <Device/DRUsb20Sh4.h>
#include <conio.h>

// virtual couplinǧW
const float K = 60;
const float B = 30;
const float dt = HAPTIC_FREQ;
#endif

// OtBbNp̕ϐ
GRSdkIf* grSdk;
GRDebugRenderIf* render;
GRDeviceGLIf* grDevice;

// vZp̕ϐ
PHSdkIf* phSdk;
PHSceneIf* scene;
PHSolidIf* soFloor;
std::vector<PHSolidIf*> soSphere; 

// SPIDARp̕ϐ
DVDeviceManager devMan;						//	D/AJE^Ȃǂ̃foCX̊Ǘ
HISpidarG6X3 spidarG6;						//	SPIDARɑΉNX

// ̑̕ϐ
Vec3f spidar_pos = Vec3f();
Vec3f sphere_pos = Vec3f();
Affinef pos_affine;
Affinef view;

bool bforce = false;
int time_counter = 0;

int sec_counter = 0;
const int one_sec = 1000 / HAPTIC_FREQ;

#define NVTX	4			//	Փ˔肷_
static Vec3f grip[NVTX]={
		Vec3f( 0.02f, 0.0f, 0.02f),
		Vec3f(-0.02f, 0.0f, 0.02f),
		Vec3f(-0.02f, 0.0f,-0.02f),
		Vec3f( 0.02f, 0.0f,-0.02f)
	};

/**
 brief     	glutDisplayFuncŎw肵R[obN֐
 param		Ȃ
 return 	Ȃ
 */
void display(){
	render->ClearBuffer();
	render->DrawScene(scene);

	// SPIDAR̈ʒu`ŕ\
	glPushMatrix();
	glMatrixMode(GL_MODELVIEW);
	Posef::Unit(spidar_pos).ToAffine(pos_affine);
	glMultMatrixf(pos_affine);
	glutSolidSphere(POINTER_RADIUS, 12, 9);
	glPopMatrix();

	render->EndScene();

	// rfI[gɂ킹邽߂60Hzɂ
	Sleep(16.66);
}

/**
 brief		̐ݒ
 param	 	Ȃ
 return 	Ȃ
 */
void setLight() {
	GRLightDesc light0, light1;
	light0.position = Vec4f(10.0, 20.0, 20.0, 1.0);
	light1.position = Vec4f(-10.0, 10.0, -20.0, 1.0);
	render->PushLight(light0);
	render->PushLight(light1);
}

/**
 brief		glutReshapeFuncŎw肵R[obN֐
 param		<in/--> w@@
 param		<in/--> h@@
 return		 Ȃ
 */
void reshape(int w, int h){
	// ViewportƎˉesݒ
	render->Reshape(Vec2f(), Vec2f(w,h));
}


MMRESULT FTimerId;

/**
 brief 		glutKeyboardFuncŎw肵R[obN֐ 
 param		<in/--> key@@ ASCIIR[h
 param 		<in/--> x@@@ L[ꂽ̃}EXW
 param 		<in/--> y@@@ L[ꂽ̃}EXW
 return 	Ȃ
 */
void keyboard(unsigned char key, int x, int y){
	if (key == ESC) 
	{
		timeKillEvent(FTimerId);
		timeEndPeriod(1);
		std::cout << "exit operation from key input" << std::endl;
		exit(0);
	}
	else if(key == 'c')
	{
		// cŃLu[V
		spidarG6.Calib();
	}
	else if(key == ' ')
	{
		bforce = !bforce;
	}
}

double dist;
double min_dist = 10000;
int index = 0;
double d = 10000;
Vec3f so_pos;

/**
 brief  	glutIdleFuncŎw肵R[obN֐
 param	 	Ȃ
 return 	Ȃ
 */
void idle(){
	scene->Step();
	glutPostRedisplay();

	// |C^̍ŋߖT̂̕T
	min_dist = 10000;
	for (unsigned int sphereCnt=0; sphereCnt<NUM_SPHERES; ++sphereCnt){
		so_pos = soSphere[sphereCnt]->GetFramePosition();
/*
		dist = sqrt(
		  pow(spidar_pos.x - so_pos.x, 2) 
		+ pow(spidar_pos.y - so_pos.y, 2) 
		+ pow(spidar_pos.z - so_pos.z, 2)
		);
*/
		dist = (spidar_pos - so_pos).norm();

		if(dist < min_dist)
		{
			// ŋߖT̂̕擾
			min_dist = dist;
			sphere_pos = soSphere[sphereCnt]->GetFramePosition();
			index = sphereCnt;
		}
	}

	// ŏ̋ݒ
	d = min_dist;

	time_counter++;

	if (++time_counter > EXIT_TIMER) 
	{
		timeKillEvent(FTimerId);
		timeEndPeriod(1);
		std::cout << "exit by count" << std::endl;
		exit(0);
	}
}

Vec3f lastPos = Vec3f();
Vec3f vel = Vec3f();
Vec3f delta = Vec3f();
const float alpha = 0.1f;
Quaternionf qt;
Vec3f force = Vec3f();
Vec3f torque = Vec3f();
const float WALL = -0.0f;
Vec3f lp = Vec3f();
Vec3f p = Vec3f();

void CALLBACK TimerProc(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	spidarG6.Update(dt);							//	USB̒ʐMsD
	spidar_pos = spidarG6.GetPos() * 60;			// spidar̈ʒui[Ăϐ̍XV
	spidar_pos = view.inv().Rot() * spidar_pos;		// SPIDAR̍W[hWł͂Ȃ̂Ń[hWɂ

#if _DEBUG
	// bƂSPIDAR̍W\
	if(sec_counter % one_sec == 0)
	{
//		std::cout << "spidar position = " << spidar_pos << std::endl;
//		std::cout << "force = " << force << "torque = " << torque << std::endl;
//		std::cout << "distance = " << d << std::endl;
		sec_counter = 0;	
	}
	sec_counter++;									// JE^[̍XV
#endif

	// xEp̗p
	delta = (spidar_pos - lastPos) / dt;
	vel = (1-alpha)*vel + alpha*delta;
	lastPos = spidar_pos;
	qt = spidarG6.GetOri();			//	px̓ǂݏo 4 Quaternionf ɂẮC}jAQ

	// ϐ̏
	force = Vec3f();
	torque = Vec3f();

	// 񎦗͂̌vZ
	for(int i=0; i<NVTX; ++i){
		lp = qt*grip[i];
		p = lp + spidar_pos;

		// nʂƂ̐ڐGvZ
		if (p.y-POINTER_RADIUS < WALL){
			// virtual couplingŒ񎦗͂̌vZ
			double temp_force = (WALL - p.y + POINTER_RADIUS) * K + B * vel.y;
			force.y += temp_force;
			torque += lp ^ Vec3f(0, temp_force, 0);
		}

		// ̂Ƃ̐ڐGvZ
		if(d < DCAST(CDSphereIf, soSphere[index]->GetShape(0))->GetRadius() + 1.0)
		{
			Vec3f temp_force = (Vec3f(3, 3, 3) + p - sphere_pos) + (vel - soSphere[index]->GetVelocity());
		
//			Vec3f sphere_force = -temp_force;
//			Vec3f sphere_torque = lp ^ (-temp_force);

			force += -temp_force;
			torque += lp ^ (-temp_force);

			soSphere[index]->AddForce(-temp_force, lp ^ (-temp_force));
		}
	}

	// gripɗ͂𔭐
	if(bforce)spidarG6.SetForce(force, torque);
	else spidarG6.SetForce(Vec3f(), Vec3f());
}


/**
 brief		C֐
 param		<in/--> argc@@R}hC͂̌
 param		<in/--> argv@@R}hC
 return		0 (I)
 */
int main(int argc, char* argv[]){
	phSdk = CreatePHSdk();					// SDK̍쐬@
	PHSceneDesc sd;
//	sd.ContactMode = PHSceneDesc::ContactMode::MODE_LCP;
	sd.timeStep = 0.017;
	scene = phSdk->CreateScene(sd);				// V[̍쐬
	PHSolidDesc desc;
	desc.mass = 2.0;
	desc.inertia *= 2.0;

	// Solid̍쐬
	for (unsigned int sphereCnt=0; sphereCnt<NUM_SPHERES; ++sphereCnt){
		soSphere.push_back(scene->CreateSolid(desc));		// ̂descɊÂč쐬
	}

	desc.mass = 1e20f;
	desc.inertia *= 1e20f;
	soFloor = scene->CreateSolid(desc);		// ̂descɊÂč쐬
	soFloor->SetGravity(false);

	//	`̍쐬
	CDBoxIf* floor=NULL;
	CDSphereIf* sphere=NULL;
	{
		CDSphereDesc sd;
		sd.radius = 2.0;
		sphere = DCAST(CDSphereIf, phSdk->CreateShape(sd));

		CDBoxDesc bd;
		bd.boxsize = Vec3f (30.0, 1.0, 30.0);
		floor = DCAST(CDBoxIf, phSdk->CreateShape(bd));
	}	

	soFloor->AddShape(floor);
	soFloor->SetFramePosition(Vec3f(0,-0.5,0));

	for (unsigned int sphereCnt=0; sphereCnt<NUM_SPHERES; ++sphereCnt){
		soSphere[sphereCnt]->AddShape(sphere);
		soSphere[sphereCnt]->SetFramePosition(Vec3f(0, 15+5*sphereCnt, 0));
	}
	scene->SetGravity(Vec3f(0,-9.8f, 0));	// d͂ݒ

	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
	glutInitWindowSize(WINSIZE_WIDTH, WINSIZE_HEIGHT);

	int window = glutCreateWindow("GRSimple");
	grSdk = CreateGRSdk();
	render = grSdk->CreateDebugRender();
	grDevice = grSdk->CreateDeviceGL(window);

	// ݒ
	grDevice->Init();

	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutKeyboardFunc(keyboard);
	glutIdleFunc(idle);
	
	render->SetDevice(grDevice);	// foCX̐ݒ

	// _ݒ肷
	
	view.Pos() = Vec3f(0.0, 5.0, -20.0);								// eye
	view.LookAtGL(Vec3f(0.0, 0.0, 0.0), Vec3f(0.0, 1.0, 0.0));			// center, up 
	view = view.inv();	
	render->SetViewMatrix(view);
	
	setLight();

	
	devMan.RPool().Register(new DRUsb20Simple(10));	//	USB2.0ŃRg[ 8[^
	devMan.RPool().Register(new DRUsb20Sh4(0));		//	Sh4ŃRg[ 8[^
	devMan.RPool().Register(new DRUsb20Sh4(1));		//	Sh4ŃRg[ 8[^
	devMan.RPool().Register(new DRUsb20Sh4(2));		//	Sh4ŃRg[ 8[^

	devMan.Init();								//	foCX̏
	std::cout << devMan;						//	̌ʂ\
	
	spidarG6.Init(devMan, false);			//	SPIDAȐCLu[VD


	Sleep(1000);					


	spidarG6.Calib();							//	Lu[V

	timeBeginPeriod(1);							//\̍ŏl

	// hapticXbh̐EJn
	FTimerId = timeSetEvent(HAPTIC_FREQ,    // ^C}[Ԋu[ms]
                        1,   // ԕ\
                        TimerProc,//R[obN֐
                        (DWORD)&time,//[U[`̒l
                        TIME_PERIODIC //P(TIME_ONESHOT) or JԂ(TIME_PERIODIC)
                        );

	glutMainLoop();

	//	SDK͊JȂĂǂDȂĂmain𔲂ĂJD
	delete phSdk;
}
